with gb; use gb;
with gb.OleInterfaces;

with Win32, Win32.WinDef, Win32.WinMain, Win32.WinUser, Win32.WinError, System;
with Win32.WinGDI, Win32.WinBase, Win32.WinNT, Win32.Utils, Interfaces.C;
use  Win32, Win32.WinError, Interfaces.C, System;

package Principale is
  Form            : aliased gb.MainWindow;
  Bouton_Quitter  : aliased gb.Button;
  Titre           : aliased gb.Label;
  Titre_Rouge     : aliased gb.CheckBox;
  Taille_Bouton_Quitter       : aliased gb.CheckBox;
  Mixer           : aliased gb.CheckBox;
  procedure Initialize_Form;
end Principale;


package body Principale is
  procedure Bouton_Quitter_Click is
  begin
  
    -- fin de l'application
    gb.EndApplication;
    
  end Bouton_Quitter_Click;

  procedure Titre_Rouge_Click is
  begin
  
    -- si la case de lobjet Titre_Rouge de la fentre Principale 
    -- est coche alors
    if Checked (Principale.Titre_Rouge) = 1 then
    
      -- change la couleur du texte du titre en rouge
      -- attention : on crit "fonction (Objet, Format);"  
      ForeColor (Principale.Titre, Red);
  
    -- si la case est dcoche, revenir  l'tat initial
    else
  
      -- exemple couleur du bleu choisi (0,128,255)
      -- la fonction Color permet dcrire en format RGB 
      ForeColor (Principale.Titre, Color (0,128,255));
  
     end if ;
  
  end Titre_Rouge_Click;

  procedure Taille_Bouton_Quitter_Click is
  begin
  
    -- si la case de lobjet Taille_Bouton_Quitter de la fentre 
    -- Principale est coche alors
    if Checked (Principale.Taille_Bouton_Quitter) = 1 then
  
        -- modifie la hauteur du bouton 
        Height (Principale.Bouton_Quitter, 100);
  
        -- modifie la largeur du bouton
        Width (Principale.Bouton_Quitter, 150);
  
    -- si la case est dcoche, revenir  l'tat initial
    else
  
        -- exemple de grandeur de dpart Height = 50 et Width =100
        Height (Principale.Bouton_Quitter, 50);
        Width (Principale.Bouton_Quitter, 100);
  
    end if ;       
  
  end Taille_Bouton_Quitter_Click;

  procedure Mixer_Click is
  begin
  
    -- si la case de lobjet Mixer de la fentre Principale est coche alors
    if Checked (Principale.Mixer) = 1 then
  
        -- vous allez changer par exemple la position des 3 cases et du titre
        -- 1ere case changez la position verticale 
        Top (Principale.Titre_Rouge, 200);
  
        -- 2eme case changez la position horizontale
        Left (Principale.Taille_Bouton_Quitter, 200);
             
        -- 3eme case changez la position verticale
        Top (Principale.Mixer, 0);
  
        -- titre changez la position verticale et horizontale
        Top (Principale.Titre, 100);
        Left (Principale.Titre, 0);
  
        -- changez la couleur du fond de la fentre et sa taille
        BackColor (Principale.Form, Black);
        Height (Principale.Form, 450);
        Width (Principale.Form, 525);
  
    -- si la case est dcoche, revenir  l'tat initial           
    else   
           
        -- 1ere case changez la position verticale 
        Top (Principale.Titre_Rouge, 120);         
  
        -- 2eme case changez la position horizontale
        Left (Principale.Taille_Bouton_Quitter, 100);
          
        -- 3eme case changez la position verticale
        Top (Principale.Mixer, 240);
           
        -- titre changez la position verticale et horizontale
        -- on utilise cette fois la procedure Move avec comme paramtres 
        -- les positions Left, Top, Width, Height (dans cet ordre)
        Move (Principale.Titre, 60, 50, 350, 30);    
           
        -- changez la couleur du fond de la fentre et sa taille (initiale)
        BackColor (Principale.Form, Color (192,192,192));
        Height (Principale.Form, 500);
        Width (Principale.Form, 500);
            
    end if ;
  
  end Mixer_Click;

  procedure Initialize_Form is
  begin
    Bouton_Quitter.Click := Bouton_Quitter_Click'Access;
    Caption(Bouton_Quitter, "Quitter");
    SetFont(Bouton_Quitter, "Times New Roman", 12, gb.False, gb.False, gb.False);
    Move(Bouton_Quitter, 169, 324, 100, 50);

    Caption(Titre, "Mon application GUI Builder");
    Alignment(Titre, gb.Center);
    SetFont(Titre, "Times New Roman", 18, gb.False, gb.False, gb.False);
    SetColors(Titre, Color(0, 128, 255), Color(192, 192, 192));
    Move(Titre, 60, 50, 350, 30);

    Titre_Rouge.Click := Titre_Rouge_Click'Access;
    Caption(Titre_Rouge, "Mettre le titre en rouge");
    Move(Titre_Rouge, 100, 120, 251, 31);

    Taille_Bouton_Quitter.Click := Taille_Bouton_Quitter_Click'Access;
    Caption(Taille_Bouton_Quitter, "Changer la taille du bouton quitter");
    Move(Taille_Bouton_Quitter, 100, 180, 251, 31);

    Mixer.Click := Mixer_Click'Access;
    Caption(Mixer, "Tremblement de terre");
    Move(Mixer, 100, 240, 251, 31);

    Caption(Form, "Accueil");
    ControlBox(Form, gb.False);
    MaxButton(Form, gb.False);
    MinButton(Form, gb.False);
    Move(Form, 42, 107, 500, 500);
    Visible(Form, gb.True);
  end Initialize_Form;
begin
  Initialize_Form;
end Principale;


with gb;
with Principale;

procedure Main is begin
  gb.StartApplication;
end Main;


